--(c) 2024 Daniel Quathamer
--freemarker template
<sqlvars>
<sqlvar name="sos_stg_aggr_exists">
select sp_table_exists('sos_stg_aggr') from xdummy
</sqlvar> 
<sqlvar name="qa_tablecomp_profile_is_active"><![CDATA[
select 1 from xdummy where 0 < (select count(*) from qa_tablecomp_profile P where P.uniquename='sos_stud_astat' and is_active=1)
union
select 0 from xdummy where 0 = (select count(*) from qa_tablecomp_profile P where P.uniquename='sos_stud_astat' and is_active=1)

]]></sqlvar> 
</sqlvars>




<#if qa_tablecomp_profile_is_active==1 && sos_stg_aggr_exists==1>
--zuerst bereinigen:es darf nur 2015er oder 2016er Lieferung geben.
--2016 hat Priorität:


create temp table tmp_sem
(
semester integer,
format integer
);
insert into tmp_sem
select distinct semester,2015
from kenn_sos_astat_2015
;
insert into tmp_sem
select distinct semester,2016
from kenn_sos_astat
;

insert into kenn_pruefrout (datum,tabelle_quelle,problem,aktion)
select distinct today(),'kenn_sos_astat'::char(18),'Semester '|| semester || ' liegt in 2015er und 2016er Format vor, 2015 wird gelöscht', 'Info'::char(10) 
from kenn_sos_astat_2015
where semester in (select T.semester
from tmp_sem T
where T.format=2016) ;  


delete from kenn_sos_astat_2015
where semester in (select T.semester
from tmp_sem T
where T.format=2016);

drop table tmp_sem;


--Unplausible Werte korrigieren:
update  kenn_sos_astat set ef010=null where substring(ef010 from 1 for 1) not in ('0','1','2','3','4','5','6','7','8','9');


create temp table tmp_stg_aggr_astat(
	hs_nr INTEGER , 
studiengang_nr SMALLINT , 
fach_nr SMALLINT ,
matrikel_nr integer,
geschlecht SMALLINT , 
ca12_staat SMALLINT , 
sem_rueck_beur_ein SMALLINT , 
stg CHAR(4) , 
sb char(19),
fgr char(10),
abschluss CHAR(2) , 
abschlussart char(10),
abgrp char(255),
regel SMALLINT , 
kz_rueck_beur_ein SMALLINT , 
fach_sem_zahl SMALLINT , 
hssem SMALLINT , 
kz_fach CHAR(1) , 
stort CHAR(10) , 
stuart CHAR(10) , 
stufrm CHAR(10) , 
hzbart_astat CHAR(10) , 
hzbkfzkz CHAR(2) ,
hrst integer ,
letzte_pruefung_stort CHAR(10) , 
letzte_pruefung_staat SMALLINT , 
letzte_pruefung_abschluss CHAR(2) , 
letzte_pruefung_ergebnis SMALLINT , 
vorletzte_pruefung_stort CHAR(10) , 
vorletzte_pruefung_staat SMALLINT , 
vorletzte_pruefung_abschluss CHAR(2) , 
vorletzte_pruefung_ergebnis SMALLINT , 
datum date , 
summe INTEGER 
) 
;


<#assign  studiengang_nr_fach_nr = [
  {"studiengang_nr":"1", "fach_nr":"1", "fach":"ef036","abschluss":"ef033u2","stufrm":"ef033u1", "regel":"ef035", "kz_rueck_beur_ein":"ef028", "fach_sem_zahl":"ef032","stuart":"ef030"},
  {"studiengang_nr":"1", "fach_nr":"2", "fach":"ef037","abschluss":"ef033u2","stufrm":"ef033u1", "regel":"ef035", "kz_rueck_beur_ein":"ef028", "fach_sem_zahl":"ef032","stuart":"ef030"},
  {"studiengang_nr":"1", "fach_nr":"3", "fach":"ef039","abschluss":"ef033u2","stufrm":"ef033u1", "regel":"ef035", "kz_rueck_beur_ein":"ef028", "fach_sem_zahl":"ef032","stuart":"ef030"},
  {"studiengang_nr":"2", "fach_nr":"1", "fach":"ef052","abschluss":"ef049u2","stufrm":"ef049u1", "regel":"ef051", "kz_rueck_beur_ein":"ef044", "fach_sem_zahl":"ef048","stuart":"ef046"},
  {"studiengang_nr":"2", "fach_nr":"2", "fach":"ef053","abschluss":"ef049u2","stufrm":"ef049u1", "regel":"ef051", "kz_rueck_beur_ein":"ef044", "fach_sem_zahl":"ef048","stuart":"ef046"},
  {"studiengang_nr":"2", "fach_nr":"3", "fach":"ef055","abschluss":"ef049u2","stufrm":"ef049u1", "regel":"ef051", "kz_rueck_beur_ein":"ef044", "fach_sem_zahl":"ef048","stuart":"ef046"}
  ] />

<#assign  studiengang_nr_fach_nr_2015 = [
  {"studiengang_nr":"1", "fach_nr":"1", "fach":"ef032","abschluss":"ef031u2","stufrm":"ef031u1", "regel":"null::char(1)", "kz_rueck_beur_ein":"ef026", "fach_sem_zahl":"ef030","stuart":"ef028"},
  {"studiengang_nr":"1", "fach_nr":"2", "fach":"ef034","abschluss":"ef031u2","stufrm":"ef031u1", "regel":"null::char(1)", "kz_rueck_beur_ein":"ef026", "fach_sem_zahl":"ef030","stuart":"ef028"},
  {"studiengang_nr":"1", "fach_nr":"3", "fach":"ef036","abschluss":"ef031u2","stufrm":"ef031u1", "regel":"null::char(1)", "kz_rueck_beur_ein":"ef026", "fach_sem_zahl":"ef030","stuart":"ef028"},
  {"studiengang_nr":"2", "fach_nr":"1", "fach":"ef047","abschluss":"ef046u2","stufrm":"ef046u1", "regel":"null::char(1)", "kz_rueck_beur_ein":"ef041", "fach_sem_zahl":"ef045","stuart":"ef043"},
  {"studiengang_nr":"2", "fach_nr":"2", "fach":"ef049","abschluss":"ef046u2","stufrm":"ef046u1", "regel":"null::char(1)", "kz_rueck_beur_ein":"ef041", "fach_sem_zahl":"ef045","stuart":"ef043"},
  {"studiengang_nr":"2", "fach_nr":"3", "fach":"ef050","abschluss":"ef046u2","stufrm":"ef046u1", "regel":"null::char(1)", "kz_rueck_beur_ein":"ef041", "fach_sem_zahl":"ef045","stuart":"ef043"}
  ] />
<#assign vorherige_pruefungen=[

{"art":"letzte", "pruefung_stort":"ef089", "pruefung_staat":"ef090", "pruefung_abschluss":"substring(ef091 from 2 for 2)", "pruefung_ergebnis":"ef097"},
{"art":"vorletzte", "pruefung_stort":"ef103", "pruefung_staat":"ef104", "pruefung_abschluss":"substring(ef105 from 2 for 2)", "pruefung_ergebnis":"ef111"}
 ] />

<#assign vorherige_pruefungen_2015=[

{"art":"letzte", "pruefung_stort":"null::char(1)", "pruefung_staat":"null::char(1)", "pruefung_abschluss":"ef091u2", "pruefung_ergebnis":"ef098"},
{"art":"vorletzte", "pruefung_stort":"null::char(1)", "pruefung_staat":"null::char(1)", "pruefung_abschluss":"ef100u2", "pruefung_ergebnis":"ef107"}
 ] />
  
<#foreach stgnr in studiengang_nr_fach_nr>
--${stgnr.studiengang_nr}. Studiengang, ${stgnr.fach_nr}. Fach:
insert into tmp_stg_aggr_astat(
hs_nr,
       studiengang_nr,
       fach_nr,
       matrikel_nr,
      geschlecht,
      ca12_staat,
       sem_rueck_beur_ein,
       stg,
       abschluss,
      regel,
      kz_rueck_beur_ein,
      fach_sem_zahl,
      hssem,
     stort,
      stuart,
      stufrm,
       hzbart_astat,
       hzbkfzkz,
       hrst,
<#if stgnr.studiengang_nr=="1" && stgnr.fach_nr=="1">
<#foreach vorherige_pruefung in vorherige_pruefungen>
${vorherige_pruefung.art}_pruefung_stort,
${vorherige_pruefung.art}_pruefung_staat,
${vorherige_pruefung.art}_pruefung_abschluss,
${vorherige_pruefung.art}_pruefung_ergebnis,
</#foreach>
</#if>
       datum,
       summe)
 select
 hs_nr,
${stgnr.studiengang_nr} as       studiengang_nr,
${stgnr.fach_nr} as       fach_nr,
val(ef006) as matrikel_nr,
val(ef007) as geschlecht,
val(ef010) as ca12_staat,
semester as       sem_rueck_beur_ein,
${stgnr.fach} as stg,
${stgnr.abschluss} as abschluss,
val(${stgnr.regel}) as regel,
val(${stgnr.kz_rueck_beur_ein}) as kz_rueck_beur_ein,
val(${stgnr.fach_sem_zahl}) as fach_sem_zahl,
val(ef021) as hssem,
ef004 as stort,
val(${stgnr.stuart}) as stuart,
${stgnr.stufrm} as stufrm,
ef118 as hzbart_astat,
ef119u1 as hzbkfzkz,
val(ef014) as hrst,
<#if stgnr.studiengang_nr=="1" && stgnr.fach_nr=="1">
<#foreach vorherige_pruefung in vorherige_pruefungen>
${vorherige_pruefung.pruefung_stort},
val(${vorherige_pruefung.pruefung_staat}),
${vorherige_pruefung.pruefung_abschluss},
val(${vorherige_pruefung.pruefung_ergebnis}),
</#foreach>
</#if>
       today(),
       count(*) as summe
FROM kenn_sos_astat 
where ${stgnr.abschluss} is not null --keine im Vorsemester exmatrikulierte
and ${stgnr.fach} is not null
group by 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20
<#if stgnr.studiengang_nr=="1" && stgnr.fach_nr=="1">
,21,22,23,24,25,26,27,28
</#if>
 ;

</#foreach>
--nun 2015, wenn vorhanden:
<#foreach stgnr in studiengang_nr_fach_nr_2015>
--${stgnr.studiengang_nr}. Studiengang, ${stgnr.fach_nr}. Fach:
insert into tmp_stg_aggr_astat(
hs_nr,
       studiengang_nr,
       fach_nr,
       matrikel_nr,
      geschlecht,
      ca12_staat,
       sem_rueck_beur_ein,
       stg,
       abschluss,
      regel,
      kz_rueck_beur_ein,
      fach_sem_zahl,
      hssem,
     stort,
      stuart,
      stufrm,
       hzbart_astat,
       hzbkfzkz,
       hrst,
<#if stgnr.studiengang_nr=="1" && stgnr.fach_nr=="1">
<#foreach vorherige_pruefung in vorherige_pruefungen_2015>
${vorherige_pruefung.art}_pruefung_stort,
${vorherige_pruefung.art}_pruefung_staat,
${vorherige_pruefung.art}_pruefung_abschluss,
${vorherige_pruefung.art}_pruefung_ergebnis,
</#foreach>
</#if>
       datum,
       summe)
 select
 hs_nr,
${stgnr.studiengang_nr} as       studiengang_nr,
${stgnr.fach_nr} as       fach_nr,
val(ef006) as matrikel_nr,
val(ef007) as geschlecht,
val(ef009) as ca12_staat,
semester as       sem_rueck_beur_ein,
${stgnr.fach} as stg,
${stgnr.abschluss} as abschluss,
val(${stgnr.regel}) as regel,
val(${stgnr.kz_rueck_beur_ein}) as kz_rueck_beur_ein,
val(${stgnr.fach_sem_zahl}) as fach_sem_zahl,
(case when ef026='1' then 1
else val(ef019) end ) as hssem,
ef004 as stort,
val(${stgnr.stuart}) as stuart,
${stgnr.stufrm} as stufrm,
ef110 as hzbart_astat,
ef111u1 as hzbkfzkz,
val(ef012) as hrst,
<#if stgnr.studiengang_nr=="1" && stgnr.fach_nr=="1">
<#foreach vorherige_pruefung in vorherige_pruefungen_2015>
${vorherige_pruefung.pruefung_stort},
val(${vorherige_pruefung.pruefung_staat}),
${vorherige_pruefung.pruefung_abschluss},
val(${vorherige_pruefung.pruefung_ergebnis}),
</#foreach>
</#if>
       today(),
       count(*) as summe
FROM kenn_sos_astat_2015 
where ${stgnr.abschluss} is not null
and ${stgnr.fach} is not null
and ${stgnr.kz_rueck_beur_ein} !='5' --keine im Vorsemester exmatrikulierte
group by 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20
<#if stgnr.studiengang_nr=="1" && stgnr.fach_nr=="1">
,21,22,23,24,25,26,27,28
</#if>
 ;

</#foreach>

update tmp_stg_aggr_astat set stg='0' || stg
where length(trim(stg))=3;

delete from qa_sos_stg_aggr_astat
where sem_rueck_beur_ein in (select distinct K.sem_rueck_beur_ein
from tmp_stg_aggr_astat K)
;


insert into qa_sos_stg_aggr_astat(hs_nr,
       studiengang_nr,
       fach_nr,
       matrikel_nr,
       geschlecht,
       ca12_staat,
       sem_rueck_beur_ein,
       stg,
       abschluss,
       fgr,
       abgrp,
       regel,
       kz_rueck_beur_ein,
       fach_sem_zahl,
       hssem,
 --      kz_fach,
       stort,
       stuart,
       stufrm,
       hzbart_astat,
       hzbkfzkz,
       hrst,
       letzte_pruefung_stort,
       letzte_pruefung_staat,
       letzte_pruefung_abschluss,
       letzte_pruefung_ergebnis,
       vorletzte_pruefung_stort,
       vorletzte_pruefung_staat,
       vorletzte_pruefung_abschluss,
       vorletzte_pruefung_ergebnis,
       datum,
       summe)
       select hs_nr,
       studiengang_nr,
       fach_nr,
       matrikel_nr,
       geschlecht,
       ca12_staat,
       sem_rueck_beur_ein,
       stg,
       abschluss,
       fgr,
       abgrp,
       regel,
       kz_rueck_beur_ein,
       fach_sem_zahl,
       hssem,
--       kz_fach,
       stort,
       stuart,
       stufrm,
       hzbart_astat,
       hzbkfzkz,
       hrst,
       letzte_pruefung_stort,
       letzte_pruefung_staat,
       letzte_pruefung_abschluss,
       letzte_pruefung_ergebnis,
       vorletzte_pruefung_stort,
       vorletzte_pruefung_staat,
       vorletzte_pruefung_abschluss,
       vorletzte_pruefung_ergebnis,
       datum,
       sum(summe)
       from tmp_stg_aggr_astat
       group by 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
       ;
update qa_sos_stg_aggr_astat set stg='0'||stg where length(stg)=3
and substring(stg from 1 for 1)  in ('0','1','2','3','4','5','6','7','8','9')
;  

drop table tmp_stg_aggr_astat;
       
</#if>
