#!/bin/bash

#Arbeitsverzeichnis fuer crontab
PFAD=$2
if [ "$PFAD" != "" ]
then

cd $PFAD

fi
#Umgebung einlesen:
if [ "$QA_PFAD" = "" ]
then
echo "ACHTUNG: Die Umgebungsvariable QA_PFAD ist nicht gesetzt. Bitte prüfen Sie $SUPERX_DIR/db/bin/SQL_ENV"

exit 1

fi
if [ "$QA_ERRORMAIL" != "" ]
then
ERRORMAIL=$QA_ERRORMAIL
export ERRORMAIL
fi
if [ "$QA_LOGMAIL" != "" ]
then
LOGMAIL=$QA_LOGMAIL
export LOGMAIL
fi
if [ "$QA_BACKUP" != "" ]
then
MODULE_BACKUP=$QA_BACKUP
export MODULE_BACKUP
fi
#hier geht es los

#bei QA gibt es keine Rohdaten, daher Tagesdatum:
date +'%d.%m.%Y' > $QA_LOAD_PFAD/superx.datum
echo "qa-Update startet" >$QA_ERRORDAT

cd $QA_PFAD
qa_mask_execution_loop.x  > $QA_PFAD/L_QA_update_Masken$MANDANTID.log 2>&1 

runAndCheck.x $QA_PFAD "module_etl.x qa $QA_PFAD $QA_LOAD_PFAD" EXIT_ON_ERROR SEND_ERRORMAIL SEND_LOGMAIL "QA update$MANDANTID"
cat $QA_PFAD/L_QA_update_Masken$MANDANTID.log >>$QA_PFAD/L_QA_update$MANDANTID.log
echo "---------------------------Beginn Prüfroutine-----------------------------------" >>$QA_ERRORDAT
#cat $QA_PFAD/L_QA_update$MANDANTID.log >>$QA_ERRORDAT
#cat $QA_PFAD/L_qa_Test$MANDANTID.log >>$QA_ERRORDAT
#pruefmail.x $QA_PFAD/L_qa_Test$MANDANTID.log $ERRORMAIL


#Bei Fehlern Datum zurücksetzen:
fgrep -s "not found" $QA_ERRORDAT
FLAG1=$?
fgrep -i -s "error" $QA_ERRORDAT
FLAG2=$?
fgrep -i -s "nicht gefunden" $QA_ERRORDAT
FLAG3=$?
fgrep -i -s "fehler" $QA_ERRORDAT
FLAG4=$?

if [ $FLAG1 -eq 0 -o $FLAG2 -eq 0 -o $FLAG3 -eq 0 -o $FLAG4 -eq 0  ]
then
        echo "Fehler beim QA-Update "
        echo "---------------------------------------"
        echo "Fehlerprotokoll in $QA_ERRORDAT"
        echo "Das Datum wird zurückgesetzt. Kopieren Sie die Datei superx.datum ggf. auf den QA-Rechner"
        echo "---------------------------------------"
        cp $QA_LOAD_PFAD/superx.datum.alt $QA_LOAD_PFAD/superx.datum
else
        echo "QA-Update erfolgreich"
	if [ "$QA_LOGMAIL" != "" -a "$MAILPROG" != "" ]
	then
	echo "Masken-Ausführung Protokoll ausführen und versenden"
		$SUPERX_DIR/db/bin/qa_tc_execution_mail.x >>$QA_ERRORDAT 2>&1
	fi

fi

